unit FreeOTFEExplorerfrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  SDUFileIterator_U,
  SDUForms,
  SDUGeneral,
  SDPartitionImage,
  SDPartitionImage_File,
  OTFEFreeOTFEDLL_PartitionImage,
  SDFilesystem,
  SDFilesystem_FAT,
  SDFilesystemCtrls,
  SDUComCtrls, ImgList, Menus, Buttons, ExtCtrls, SDUDialogs, ActnList,
  OTFE_U, OTFEConsts_U, OTFEFreeOTFEBase_U, OTFEFreeOTFEDLL_U, SDUDropFiles, CommonfrmMain,
  XPMan, ToolWin,
  SDUMRUList,
  CommonSettings;

type
  TLastFocussed = (lfTreeView, lfListView, lfTreePopup);

  TfrmFreeOTFEExplorerMain = class(TfrmMain)
    pnlTopSpacing: TPanel;
    pmTreeView: TPopupMenu;
    pmListView: TPopupMenu;
    mnuTreeViewExpand: TMenuItem;
    mnuExploreView: TMenuItem;
    mnuListViewExtract: TMenuItem;
    SDUOpenDialog_MountPlaintextImage: TSDUOpenDialog;
    ImageList_StatusBar: TImageList;
    mnuListViewStore: TMenuItem;
    mnuListViewStoreFile: TMenuItem;
    mnuListViewStoreDir: TMenuItem;
    mnuViewDelete: TMenuItem;
    N3: TMenuItem;
    mnuViewProperties: TMenuItem;
    mnuViewCreateSubDir: TMenuItem;
    mnuTreeViewCollapse: TMenuItem;
    SDUOpenDialog_Store: TSDUOpenDialog;
    SDUSaveDialog_Extract: TSDUSaveDialog;
    SDUDropFilesTreeView: TSDUDropFiles;
    SDUDropFilesListView: TSDUDropFiles;
    actPlaintextMountFile: TAction;
    Mountplaintextimage1: TMenuItem;
    Edit2: TMenuItem;
    actSelectAll: TAction;
    Selectall1: TMenuItem;
    actShowBootSector: TAction;
    actCheckFilesystem: TAction;
    actListStyleSmallIcons: TAction;
    actListStyleIcons: TAction;
    actListStyleList: TAction;
    actListStyleDetails: TAction;
    N1: TMenuItem;
    Icons1: TMenuItem;
    SmallIcons1: TMenuItem;
    List1: TMenuItem;
    Details1: TMenuItem;
    actCheckStatusBar: TAction;
    actCheckAddressBar: TAction;
    oolbars1: TMenuItem;
    Statusbar2: TMenuItem;
    N2: TMenuItem;
    Addressbar1: TMenuItem;
    N6: TMenuItem;
    Showbootsectordetails1: TMenuItem;
    Checkfilesystem1: TMenuItem;
    pmToolbarBack: TPopupMenu;
    pmToolbarViews: TPopupMenu;
    pmToolbarForward: TPopupMenu;
    pnlExplorer: TPanel;
    SDFilesystemListView1: TSDFilesystemListView;
    Splitter1: TSplitter;
    SDFilesystemTreeView1: TSDFilesystemTreeView;
    pnlAddressBar: TPanel;
    lblFolder: TLabel;
    edPath: TEdit;
    pbGo: TBitBtn;
    ToolbarExplorer: TToolBar;
    tbbNavigateBack: TToolButton;
    tbbNavigateForward: TToolButton;
    tbbUp: TToolButton;
    ToolButton3: TToolButton;
    tbbMoveTo: TToolButton;
    tbbCopyTo: TToolButton;
    ToolButton1: TToolButton;
    tbbDelete: TToolButton;
    ToolButton4: TToolButton;
    tbbViews: TToolButton;
    ToolBarVolume: TToolBar;
    tbbNew: TToolButton;
    ToolButton2: TToolButton;
    tbbMountFile: TToolButton;
    ToolButton5: TToolButton;
    tbbDismount: TToolButton;
    actCheckToolbarVolume: TAction;
    actCheckToolbarExplorer: TAction;
    StandardButtons1: TMenuItem;
    Volume1: TMenuItem;
    tbbExtract: TToolButton;
    tbbStore: TToolButton;
    ToolButton6: TToolButton;
    Icons2: TMenuItem;
    SmallIcons2: TMenuItem;
    List2: TMenuItem;
    Details2: TMenuItem;
    actDelete: TAction;
    actStoreFile: TAction;
    actExtract: TAction;
    pmToolbarStore: TPopupMenu;
    actStoreDir: TAction;
    mnuToolbarStoreFile: TMenuItem;
    mnuToolbarStoreDir: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    actCreateSubDir: TAction;
    tbbItemProperties: TToolButton;
    ToolButton8: TToolButton;
    actItemProperties: TAction;
    N10: TMenuItem;
    mnuTreeViewCreateSubDir: TMenuItem;
    mnuTreeViewDelete: TMenuItem;
    N11: TMenuItem;
    mnuTreeViewExtract: TMenuItem;
    mnuTreeViewStore: TMenuItem;
    mnuTreeViewStoreFile: TMenuItem;
    mnuTreeViewStoreDir: TMenuItem;
    N12: TMenuItem;
    mnuTreeViewItemProperties: TMenuItem;
    actUpDir: TAction;
    actNavigateBack: TAction;
    actNavigateForward: TAction;
    Options1: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    mnuMainExtract: TMenuItem;
    mnuMainStore: TMenuItem;
    File2: TMenuItem;
    Folder1: TMenuItem;
    Plaintextimage1: TMenuItem;
    miPlaintextDismount: TMenuItem;
    actPlaintextNew: TAction;
    New1: TMenuItem;
    procedure pbGoClick(Sender: TObject);
    procedure edPathKeyPress(Sender: TObject; var Key: Char);
    procedure mnuTreeViewExpandClick(Sender: TObject);
    procedure mnuExploreViewClick(Sender: TObject);
    procedure pmViewPopup(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SDFilesystemListView1SelectItem(Sender: TObject;
      Item: TListItem; Selected: Boolean);
    procedure SDFilesystemTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormResize(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure mnuTreeViewCollapseClick(Sender: TObject);
    procedure actAboutExecute(Sender: TObject);
    procedure actRefreshExecute(Sender: TObject);
    procedure actPlaintextMountFileExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actDismountExecute(Sender: TObject);
    procedure actSelectAllExecute(Sender: TObject);
    procedure actShowBootSectorExecute(Sender: TObject);
    procedure actCheckFilesystemExecute(Sender: TObject);
    procedure actListStyleExecute(Sender: TObject);
    procedure actCheckStatusBarExecute(Sender: TObject);
    procedure actCheckAddressBarExecute(Sender: TObject);
    procedure actCheckToolbarVolumeExecute(Sender: TObject);
    procedure actCheckToolbarExplorerExecute(Sender: TObject);
    procedure actStoreFileExecute(Sender: TObject);
    procedure actStoreDirExecute(Sender: TObject);
    procedure actCreateSubDirExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure actItemPropertiesExecute(Sender: TObject);
    procedure actExtractExecute(Sender: TObject);
    procedure SDFilesystemTreeView1ContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure SDFilesystemListView1Enter(Sender: TObject);
    procedure SDFilesystemTreeView1Enter(Sender: TObject);
    procedure SDFilesystemListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure actUpDirExecute(Sender: TObject);
    procedure actNavigateBackExecute(Sender: TObject);
    procedure actNavigateForwardExecute(Sender: TObject);
    procedure tbbWithDropDownMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pmToolbarBackPopup(Sender: TObject);
    procedure pmToolbarForwardPopup(Sender: TObject);
    procedure actFreeOTFENewExecute(Sender: TObject);
    procedure actOptionsExecute(Sender: TObject);
    procedure edPathChange(Sender: TObject);
    procedure SDUDropFilesTreeViewItemsDrop(Sender: TObject;
      DropItems: TStringList; DropPoint: TPoint);
    procedure SDUDropFilesListViewItemsDrop(Sender: TObject;
      DropItems: TStringList; DropPoint: TPoint);
    procedure actPlaintextNewExecute(Sender: TObject);
  private
    PartitionImage: TSDPartitionImage;
    Filesystem: TSDFilesystem_FAT;
  protected
    LastFocussed: TLastFocussed;

    FNavigateHistory: TStringList;
    FNavigateIdx: integer;

    function  UserGuideURL(): string; override;

    procedure ReloadSettings(); override;

    procedure RefreshMRUList(); override;
    procedure MRUListItemClicked(mruList: TSDUMRUList; idx: integer); override;

    procedure MountFiles(mountAsSystem: TDragDropFileType; filenames: TStringList; readOnly: boolean); overload; override;

    procedure PostMountGUISetup(filename: string; driveLetter: char);

    procedure RecaptionToolbarAndMenuIcons(); override;
    procedure SetIconListsAndIndexes(); override;
    procedure SetupToolbarFromSettings(); override;

    procedure MountPlaintextImage(filename: string; mountReadonly: boolean);

    // These functions carry out the extract/store operations...
    function  CreateSubDir(path: WideString; newDirName: WideString): boolean;
    function  StoreFile(path: WideString; fileToStore: string): boolean;
    function  StoreDir(path: WideString; dirToStore: string): boolean;
    function  ExtractFile(srcFile: string; destFile: string): boolean;
    function  ExtractDir(srcDir: string; destDir: string): boolean;

    function  Mounted(): boolean;

    procedure SetTitleCaption();

    procedure SetStatusMsg(); overload;
    procedure SetStatusMsg(msg: string); overload;
    function  DefaultStatusMsg(): string;
    function  SelectedItemsStatusMsg(): string;
    procedure SizeStatusBar();

    procedure Dismount(); overload;
    procedure Dismount(driveLetter: char); overload;

    procedure PromptForAndImportFile(importToPath: WideString);
    procedure PromptForAndImportDir(importToPath: WideString);
    procedure ConfirmForAndImportMultiple(srcItems: TStringList; importToPath: WideString);
    function  ImportMultiple(srcItems: TStringList; importToPath: WideString; showMsgOnSuccess: boolean): boolean;
    function  ImportFile(srcItem: WideString; importToPath: WideString; showMsgOnSuccess: boolean): boolean;
    function  ImportDir(srcItem: WideString; importToPath: WideString; showMsgOnSuccess: boolean): boolean;

    procedure GetSelectedItems(Sender: TObject; targets: TStringList);
    function  GetSelectedPath(Sender: TObject): string;

    procedure OnNavigationMenuItemClick(Sender: TObject);
    procedure NavigateToHistoryIdx(idx: integer);

  public
    // This next line will generate a compiler warning - this is harmless.
    // (We want to use OTFEFreeOTFE as the descendant class in this unit)
    function  OTFEFreeOTFE(): TOTFEFreeOTFEDLL; overload;

    procedure InitApp(); override;

    procedure SetupControls();
    procedure EnableDisableControls(); override;
  end;

var
  frmFreeOTFEExplorerMain: TfrmFreeOTFEExplorerMain;

implementation

{$R *.dfm}

uses
// Turn off useless hints about FileCtrl.pas being platform specific
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}
  FileCtrl,
{$WARN UNIT_PLATFORM ON}
{$WARN SYMBOL_PLATFORM ON}
  Math,
  FreeOTFEExplorerConsts,
  FreeOTFEExplorerSettings,
  CommonfrmAbout,
  SDUGraphics,
  SDUi18n,
  SDUSysUtils,
  SDUAboutDlg,
  SDFATBootSectorPropertiesDlg,
  FreeOTFEExplorerfrmNewDirDlg,
  FreeOTFEExplorerfrmOptions,
  FreeOTFEExplorerfrmPropertiesDlg_File,
  FreeOTFEExplorerfrmPropertiesDlg_Directory,
  FreeOTFEExplorerfrmPropertiesDlg_Multiple,
  OTFEFreeOTFE_frmNewVolumeSize;

{$IFDEF _NEVER_DEFINED}
// This is just a dummy const to fool dxGetText when extracting message
// information
// This const is never used; it's #ifdef'd out - SDUCRLF in the code refers to
// picks up SDUGeneral.SDUCRLF
const
  SDUCRLF = ''#13#10;
{$ENDIF}

resourcestring
  FOTFE_EXPL_DESCRIPTION  = 'An explorer-type application to allow access to FreeOTFE volumes, without requiring administrator rights to install any drivers';

  // Toolbar captions
  RS_TOOLBAR_CAPTION_BACK    = 'Back';
  RS_TOOLBAR_CAPTION_FORWARD = 'Forward';
  RS_TOOLBAR_CAPTION_UP      = 'Up';
  RS_TOOLBAR_CAPTION_MOVETO  = 'Move to';
  RS_TOOLBAR_CAPTION_COPYTO  = 'Copy to';
  RS_TOOLBAR_CAPTION_DELETE  = 'Delete';
  RS_TOOLBAR_CAPTION_VIEWS   = 'Views';
  RS_TOOLBAR_CAPTION_EXTRACT = 'Extract';
  RS_TOOLBAR_CAPTION_STORE   = 'Store';
  RS_TOOLBAR_CAPTION_ITEMPROPERTIES = 'Properties';

  RS_TOOLBAR_MNU_CAPTION_STORE_FILE = 'Store file...';
  RS_TOOLBAR_MNU_CAPTION_STORE_DIR  = 'Store folder...';

  // Toolbar hints
  RS_TOOLBAR_HINT_BACK            = 'Back';
  RS_TOOLBAR_HINT_FORWARD         = 'Forward';
  RS_TOOLBAR_HINT_UP              = 'Up';
  RS_TOOLBAR_HINT_MOVETO          = 'Move to';
  RS_TOOLBAR_HINT_COPYTO          = 'Copy to';
  RS_TOOLBAR_HINT_DELETE          = 'Delete';
  RS_TOOLBAR_HINT_VIEWS           = 'Views';
  RS_TOOLBAR_HINT_EXTRACT         = 'Extract selected files/folders from the mounted volume';
  RS_TOOLBAR_HINT_STORE           = 'Store a file/folder in the mounted volume';
  RS_TOOLBAR_HINT_ITEMPROPERTIES  = 'Properties';

  RS_TOOLBAR_MNU_HINT_STORE_FILE  = 'Store file';
  RS_TOOLBAR_MNU_HINT_STORE_DIR   = 'Store folder';

  // Open/Save file filters...
  FILE_FILTER_FLT_PLAINTEXTIMAGES      = 'Image files (*.img)|*.img|All files|*.*';
  FILE_FILTER_DFLT_PLAINTEXTIMAGES     = 'img';

const
  STATUSBAR_PANEL_STATUS        = 0;
  STATUSBAR_PANEL_SELECTEDITEMS = 1;
  STATUSBAR_PANEL_LOCATION      = 2;

  // These icon indexes must match those in ImageList_StatusBar
  IMGLIST_IDX_FREEOTFE = 0;

  // Max number of menu items to show in the Back/Forward button dropdown menus
  MAX_BACKFORWARD_NAV_MENUITEMS  = 10;
  // Max number of items in the history
  MAX_BACKFORWARD_NAV_TOTALITEMS = 50;

  // Online user manual URL...
  USERGUIDE_ONLINE_EXPLORER = 'http://www.FreeOTFE.org/docs/Explorer';


// This procedure is called after OnCreate, and immediatly before the
// Application.Run() is called
procedure TfrmFreeOTFEExplorerMain.InitApp();
begin
  // We call EnableDisableControls(...) at this point, to display the
  // toolbar/statusbar as needed
  EnableDisableControls();

  SetupToolbarFromSettings();
  // SetupToolbarFromSettings(...) can change the window's width if large 
  // icons are being used
  // We recenter the window here so it looks right
  self.Position := poScreenCenter;

  if not(ActivateFreeOTFEComponent(TRUE)) then
    begin
    SDUMessageDlg(
               _('The main FreeOTFE driver could not be found on this computer'+SDUCRLF+
               SDUCRLF+
               'Please check your installation'),
               mtError
              );
    end;

  EnableDisableControls();
  SetupPKCS11(FALSE);

end;

// Reload settings, setting up any components as needed
procedure TfrmFreeOTFEExplorerMain.ReloadSettings();
begin
  inherited;

  SDUClearPanel(pnlTopSpacing);
  SDUClearPanel(pnlAddressBar);
  SDUClearPanel(pnlExplorer);

  SetupToolbarFromSettings();

  SetTitleCaption();

  actCheckToolbarVolume.Checked := Settings.OptDisplayToolbarVolume;
  actCheckToolbarExplorer.Checked := Settings.OptDisplayToolbarExplorer;
  actCheckAddressBar.Checked := Settings.OptDisplayAddressBar;
  case Settings.OptDisplayListViewStyle of
    vsReport:
      begin
      actListStyleDetails.Checked := TRUE;
      end;

    vsList:
      begin
      actListStyleList.Checked := TRUE;
      end;

    vsIcon:
      begin
      actListStyleIcons.Checked := TRUE;
      end;

    vsSmallIcon:
      begin
      actListStyleSmallIcons.Checked := TRUE;
      end;
  end;
  actCheckStatusBar.Checked := Settings.OptDisplayStatusbar;

end;

procedure TfrmFreeOTFEExplorerMain.MountFiles(mountAsSystem: TDragDropFileType; filenames: TStringList; readOnly: boolean);
var
  mountedAs: string;
  mountedOK: boolean;
  singleFilename: string;
begin
  // Sanity check
  if (filenames.count <> 1) then
    begin
    SDUMessageDlg('Please specify a single volume to be mounted', mtError);
    exit;
    end;

  Dismount();

  AddToMRUList(filenames);

  if (mountAsSystem = ftFreeOTFE) then
    begin
    mountedOK:= OTFEFreeOTFE.MountFreeOTFE(filenames, mountedAs, readOnly);
    end
  else if (mountAsSystem = ftLinux) then
    begin
    mountedOK:= OTFEFreeOTFE.MountLinux(filenames, mountedAs, readOnly);
    end
  else
    begin
    mountedOK:= OTFEFreeOTFE.Mount(filenames, mountedAs, readOnly);
    end;

  if not(mountedOK) then
    begin
    if (OTFEFreeOTFE.LastErrorCode <> OTFE_ERR_USER_CANCEL) then
      begin
      SDUMessageDlg(
                    _('Unable to mount volume.')+SDUCRLF+
                    SDUCRLF+
                    _('Please check your password and settings, and try again.'),
                    mtError
                   );
      end;
    end
  else
    begin
    // Only the first filename is used; policed above in sanity check making
    // sure only one filename is passed in
    singleFilename := filenames[0];
    PostMountGUISetup(singleFilename, mountedAs[1]);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.RefreshMRUList();
begin
  inherited;

  // Refresh menuitems...
  Settings.OptMRUList.RemoveMenuItems(mmMain);
  Settings.OptMRUList.InsertAfter(miLinuxVolume);

end;

procedure TfrmFreeOTFEExplorerMain.MRUListItemClicked(mruList: TSDUMRUList; idx: integer);
begin
//lplp - this isnt' right; should cater for plaintext images, and linux volumes being in the MRU list
//  MountFilesDetectLUKS(mruList.Items[idx], FALSE, Settings.OptDragDropFileType);
  MountFilesDetectLUKS(mruList.Items[idx], FALSE, ftFreeOTFE);  // ftPrompt ?
end;

// Configure up the GUI, assuming the filename supplied has been mounted under
// the "drive letter" supplied
procedure TfrmFreeOTFEExplorerMain.PostMountGUISetup(filename: string; driveLetter: char);
begin
  PartitionImage := TOTFEFreeOTFEDLL_PartitionImage.Create();
  TOTFEFreeOTFEDLL_PartitionImage(PartitionImage).FreeOTFEObj := OTFEFreeOTFE;
  TOTFEFreeOTFEDLL_PartitionImage(PartitionImage).Filename := filename;
  TOTFEFreeOTFEDLL_PartitionImage(PartitionImage).MountedAs := driveLetter;
  PartitionImage.Mounted := TRUE;

  if not(PartitionImage.Mounted) then
    begin
    PartitionImage.Free();
    PartitionImage := nil;
    SDUMessageDlg('Volume could be mounted, but not mounted as a partition image?!', mtError);
    end;

  if (PartitionImage <> nil) then
    begin
    Filesystem := TSDFilesystem_FAT.Create();
    Filesystem.PartitionImage := PartitionImage;
    try
      Filesystem.Mounted := TRUE;
    except
      on E:EFileSystemNotRecognised do
        begin
        SDUMessageDlg(_('The filesystem used by this volume could not be recognised as either FAT12, FAT16 or FAT32.'), mtError);
        Dismount();
        end;
    end;
    end;

  if (Filesystem <> nil) then
    begin
    if Filesystem.Mounted then
      begin
      SetupControls();
      SetTitleCaption();
      end;
    end;

  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.SetupControls();
begin
  FNavigateHistory.Clear();
  FNavigateIdx := -1;

  SDFilesystemListView1.Filesystem := Filesystem;
  SDFilesystemTreeView1.Filesystem := Filesystem;

  SDFilesystemListView1.Initialize();
  SDFilesystemTreeView1.Initialize();

  // Expand out the root node
  if (SDFilesystemTreeView1.GoToPath(PATH_SEPARATOR, FALSE) <> nil) then
    begin
    SDFilesystemTreeView1.Selected.Expand(FALSE);
    end;

  SDFilesystemTreeView1.SetFocus();

  SetStatusMsg();

  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.pbGoClick(Sender: TObject);
begin
  edPath.text := trim(edPath.text);
  if (SDFilesystemTreeView1.GoToPath(edPath.text, FALSE) = nil) then
    begin
    SDUMessageDlg(SDUParamSubstitute(
                                     _('Path not found:'+SDUCRLF+
                                     SDUCRLF+
                                     '%1'),
                                     [edPath.text]
                                    ), mtError);
    end;

end;


procedure TfrmFreeOTFEExplorerMain.edPathChange(Sender: TObject);
begin
  inherited;
  pbGo.Hint := SDUParamSubstitute(_('Go to ''%1'''), [trim(edPath.text)]);
  pbGo.ShowHint := TRUE;
end;

procedure TfrmFreeOTFEExplorerMain.edPathKeyPress(Sender: TObject; var Key: Char);
begin
  // <ENTER> is the same as pressing the "Go" button
  if (Key = #13) then
    begin
    pbGoClick(nil);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.mnuTreeViewCollapseClick(Sender: TObject);
var
  popupNode: TTreeNode;
begin
  // pmTreeView.Tag set to the node rightclicked on by
  // SDFilesystemTreeView1ContextPopup(...)
  popupNode := TTreeNode(pmTreeView.Tag);
  popupNode.Collapse(FALSE);

  // DO NOT USE THIS - THE USER MIGHT HAVE RIGHTCLICKED ON A DIFFERENT NODE TO
  // THE ONE SELECTED
  //  SDFilesystemTreeView1.Selected.Collapse(FALSE);
end;

procedure TfrmFreeOTFEExplorerMain.mnuTreeViewExpandClick(Sender: TObject);
var
  popupNode: TTreeNode;
begin
  // pmTreeView.Tag set to the node rightclicked on by
  // SDFilesystemTreeView1ContextPopup(...)
  popupNode := TTreeNode(pmTreeView.Tag);
  popupNode.Expand(FALSE);

  // DO NOT USE THIS - THE USER MIGHT HAVE RIGHTCLICKED ON A DIFFERENT NODE TO
  // THE ONE SELECTED
  //  SDFilesystemTreeView1.Selected.Expand(FALSE);
end;

procedure TfrmFreeOTFEExplorerMain.mnuExploreViewClick(Sender: TObject);
begin
  if (SDFilesystemListView1.SelCount > 0) then
    begin
    SDFilesystemTreeView1.GoToPath(
                                   IncludeTrailingPathDelimiter(SDFilesystemListView1.Path)+SDFilesystemListView1.DirItem[SDFilesystemListView1.SelectedIdx].Filename,
                                   TRUE
                                  );
    end;
end;

procedure TfrmFreeOTFEExplorerMain.pmToolbarBackPopup(Sender: TObject);
var
  tmpMenuItem: TMenuItem;
  i: integer;
begin
  pmToolbarBack.Items.Clear();
  for i:=(FNavigateIdx - 1) downto max(
                                0,
                                (FNavigateIdx - MAX_BACKFORWARD_NAV_MENUITEMS)
                               ) do
    begin
    tmpMenuItem:= TMenuItem.Create(nil);
    tmpMenuItem.Caption := FNavigateHistory[i];
    tmpMenuItem.OnClick := OnNavigationMenuItemClick;
    tmpMenuItem.Tag := i;
    pmToolbarBack.Items.Add(tmpMenuItem);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.pmToolbarForwardPopup(Sender: TObject);
var
  tmpMenuItem: TMenuItem;
  i: integer;
begin
  pmToolbarForward.Items.Clear();
  for i:=(FNavigateIdx + 1) to min(
                            (FNavigateHistory.Count - 1),
                            (FNavigateIdx + MAX_BACKFORWARD_NAV_MENUITEMS)
                           ) do
    begin
    tmpMenuItem:= TMenuItem.Create(nil);
    tmpMenuItem.Caption := FNavigateHistory[i];
    tmpMenuItem.OnClick := OnNavigationMenuItemClick;
    tmpMenuItem.Tag := i;
    pmToolbarForward.Items.Add(tmpMenuItem);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.OnNavigationMenuItemClick(Sender: TObject);
var
  targetIdx: integer;
begin
  targetIdx := TMenuItem(Sender).Tag;

  // Sanity check
  if (
      (FNavigateHistory.Count > 0) and
      (targetIdx >= 0) and
      (targetIdx <= (FNavigateHistory.Count - 1))
     ) then
    begin
    NavigateToHistoryIdx(targetIdx);
    end;

end;


procedure TfrmFreeOTFEExplorerMain.pmViewPopup(Sender: TObject);
begin
  EnableDisableControls();
end;

function TfrmFreeOTFEExplorerMain.ExtractFile(srcFile: string; destFile: string): boolean;
var
  retval: boolean;
begin
  SetStatusMsg(SDUParamSubstitute(_('Extracting: %1'), [srcFile]));
  retval := Filesystem.ExtractFile(srcFile, destFile);
  if not(retval) then
    begin
    SDUMessageDlg(
                  _('Unable to extract file:')+SDUCRLF+
                  SDUCRLF+
                  srcFile,
                  mtError
                 );
    end;

  Result := retval;
end;

function TfrmFreeOTFEExplorerMain.ExtractDir(srcDir: string; destDir: string): boolean;
var
  dirContent: TSDDirItemList;
  i: integer;
  retval: boolean;
begin
  retval:= TRUE;

  dirContent:= TSDDirItemList.Create();
  try
    SetStatusMsg(SDUParamSubstitute(_('Extracting: %1'), [srcDir]));

    if not(Filesystem.LoadContentsFromDisk(srcDir, dirContent)) then
      begin
      retval := FALSE;
      // Reset cursor for message dialog
      Screen.Cursor := crDefault;
      SDUMessageDlg(
                    _('Unable to get directory listing for:')+SDUCRLF+
                    SDUCRLF+
                    srcDir,
                    mtError
                   );
      end
    else
      begin
      try
        mkdir(destDir);
      except
        // Swallow any exception; assume the directory already existed
      end;

      for i:=0 to (dirContent.count - 1) do
        begin
        if dirContent[i].IsFile then
          begin
          retval := ExtractFile(
                                IncludeTrailingPathDelimiter(srcDir)+dirContent[i].Filename,
                                IncludeTrailingPathDelimiter(destDir)+dirContent[i].Filename
                               );
          end
        else if (
                 dirContent[i].IsDirectory and
                 (dirContent[i].Filename <> DIR_CURRENT_DIR) and
                 (dirContent[i].Filename <> DIR_PARENT_DIR)
                ) then
          begin
          retval := ExtractDir(
                               IncludeTrailingPathDelimiter(srcDir)+dirContent[i].Filename,
                               IncludeTrailingPathDelimiter(destDir)+dirContent[i].Filename
                              );
          end;

        if not(retval) then
          begin
          break;
          end;
        end;

      end;

  finally
    dirContent.Free();
  end;

  Result := retval;
end;


procedure TfrmFreeOTFEExplorerMain.EnableDisableControls();
var
  mountedWritable: boolean;
  selectedTargets: TStringList;
begin
  inherited;

  // Inherited controls...
  actDismount.enabled   := Mounted();

  mountedWritable := FALSE;
  if (Filesystem <> nil) then
    begin
    mountedWritable := (
                        Mounted() and
                        not(Filesystem.Readonly)
                       );
    end;

  // Controls only enabled when mounted...
  SDUEnableControl(actNavigateBack, (
                                     Mounted() and
                                     (FNavigateIdx > 0)
                                    ));
  SDUEnableControl(actNavigateForward, (
                                     Mounted() and
                                     (FNavigateIdx < (FNavigateHistory.Count - 1))
                                    ));
  SDUEnableControl(edPath, Mounted());
  SDUEnableControl(pbGo, (
                          Mounted() and
                          (trim(edPath.text) <> '')
                         ));
  SDUEnableControl(SDFilesystemListView1, Mounted());
  SDUEnableControl(SDFilesystemTreeView1, Mounted());
  SDUEnableControl(actSelectAll, Mounted());
  SDUEnableControl(actShowBootSector, Mounted());
  SDUEnableControl(actCheckFilesystem, Mounted());
  SDUEnableControl(actUpDir, (
                              Mounted() and
                              (SDFilesystemTreeView1.PathToNode(SDFilesystemTreeView1.Selected) <> PATH_SEPARATOR)
                             ));

  // Controls only enabled when mounted for read/write...
  SDUEnableControl(tbbStore, mountedWritable);
  SDUEnableControl(mnuMainStore, mountedWritable);
  SDUEnableControl(actStoreFile, mountedWritable);
  SDUEnableControl(actStoreDir, mountedWritable);
  SDUEnableControl(actCreateSubDir, mountedWritable);
  SDUEnableControl(actDelete, mountedWritable);

  // Only allow drag and drop to store files/dirs if mounted for read/write...
  SDUDropFilesTreeView.Active := mountedWritable;
  SDUDropFilesListView.Active := mountedWritable;


  mnuTreeViewExpand.Visible := (
                                (SDFilesystemTreeView1.SelectionCount = 1) and
                                not(SDFilesystemTreeView1.Selected.Expanded)
                               );
  mnuTreeViewCollapse.Visible := (
                                  (SDFilesystemTreeView1.SelectionCount = 1) and
                                  SDFilesystemTreeView1.Selected.Expanded
                                 );

  SDUEnableControl(
                   mnuExploreView,
                   (
                    (SDFilesystemListView1.SelCount = 1) and
                    SDFilesystemListView1.DirItem[SDFilesystemListView1.SelectedIdx].IsDirectory
                   )
                  );

  selectedTargets := TStringList.Create();
  try
    GetSelectedItems(nil, selectedTargets);

    SDUEnableControl(actExtract, (
                                  Mounted() and
                                  (selectedTargets.Count > 0)
                                 ));
    SDUEnableControl(actItemProperties, actExtract.Enabled);
  finally
    selectedTargets.Free();
  end;

  // IMPORTANT!
  // Because the treeview's menuitems have their actionitem set to nil in
  // FormCreate(...), these must be enabled/disabled to match the appropriate
  // actionitem
  // SDUEnableControl(mnuTreeViewExtract, actExtract.enabled);  // Don't mirror this one - if we're displaying the context menu, we can always extract
  SDUEnableControl(mnuTreeViewStoreFile, actStoreFile.enabled);
  SDUEnableControl(mnuTreeViewStoreDir, actStoreDir.enabled);
  SDUEnableControl(mnuTreeViewCreateSubDir, actCreateSubDir.enabled);
  SDUEnableControl(mnuTreeViewDelete, actDelete.enabled);
  SDUEnableControl(mnuTreeViewItemProperties, actItemProperties.enabled);


  // Note: Toolbars setup by inherited method, apart from visible/invisible;
  //       setup here
  ToolBarVolume.Visible := Settings.OptDisplayToolbarVolume;
  ToolBarExplorer.Visible := Settings.OptDisplayToolbarExplorer;

  pnlAddressBar.Visible := Settings.OptDisplayAddressBar;
  pnlTopSpacing.Visible := not(pnlAddressBar.Visible);

  // Set .Top on aligned "alTop" components so they are shown in the correct order
  pnlTopSpacing.Top   := 0;
  ToolBarExplorer.Top := 0;
  ToolBarVolume.Top   := 0;

  SDFilesystemListView1.ViewStyle := Settings.OptDisplayListViewStyle;

end;

procedure TfrmFreeOTFEExplorerMain.SetTitleCaption();
var
  volFilename: string;
begin
  volFilename := '';
  if Mounted() then
    begin
    if (PartitionImage is TOTFEFreeOTFEDLL_PartitionImage) then
      begin
      volFilename := TOTFEFreeOTFEDLL_PartitionImage(PartitionImage).Filename;
      end
    else if (PartitionImage is TSDPartitionImage_File) then
      begin
      volFilename := TSDPartitionImage_File(PartitionImage).Filename;
      end;
    end;

  if (volFilename = '') then
    begin
    self.Caption := Application.Title;
    end
  else
    begin
    self.Caption := Application.Title + ' - ' + ExtractFilename(volFilename);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.SetStatusMsg();
begin
  SetStatusMsg('');
end;

procedure TfrmFreeOTFEExplorerMain.SetStatusMsg(msg: string);
begin
  if (msg = '') then
    begin
    msg := DefaultStatusMsg();

    // If setting to default status message, update the selected items panel
    if (Filesystem = nil) then
      begin
      StatusBar1.Panels[STATUSBAR_PANEL_SELECTEDITEMS].Text := '';
      end
    else
      begin
      StatusBar1.Panels[STATUSBAR_PANEL_SELECTEDITEMS].Text := SelectedItemsStatusMsg();
      end;

    StatusBar1.Panels[STATUSBAR_PANEL_LOCATION].Text := '';
    if (Filesystem <> nil) then
      begin
      StatusBar1.Panels[STATUSBAR_PANEL_LOCATION].Text := _('Secure volume');
      if (PartitionImage is TSDPartitionImage_File) then
        begin
        StatusBar1.Panels[STATUSBAR_PANEL_LOCATION].Text := _('Plaintext volume');
        end;
      end;
    end;

  SizeStatusBar();
  StatusBar1.Panels[STATUSBAR_PANEL_STATUS].Text := msg;
  Application.ProcessMessages();  // Required in order to get display to
                                  // update when called in a loop
                                  // (e.g. when processing multiple files, etc)
end;


procedure TfrmFreeOTFEExplorerMain.SizeStatusBar();
begin
  // These values approximate the sizes of the panels Windows Explorer uses
  // (under Windows XP, with no themes, at any rate)
  StatusBar1.Panels[STATUSBAR_PANEL_SELECTEDITEMS].Width :=  80;
  StatusBar1.Panels[STATUSBAR_PANEL_LOCATION].Width      := 165;

  StatusBar1.Panels[STATUSBAR_PANEL_STATUS].Width := self.width - (
                                                        StatusBar1.Panels[STATUSBAR_PANEL_SELECTEDITEMS].Width +
                                                        StatusBar1.Panels[STATUSBAR_PANEL_LOCATION].Width
                                                       ); 
end;

procedure TfrmFreeOTFEExplorerMain.actAboutExecute(Sender: TObject);
var
  dlg: TfrmAbout;
begin
  dlg := TfrmAbout.Create(self);
  try
    dlg.FreeOTFEObj := OTFEFreeOTFE;
    dlg.BetaNumber  := APP_BETA_BUILD;
    dlg.Description := FOTFE_EXPL_DESCRIPTION;
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;


procedure TfrmFreeOTFEExplorerMain.actRefreshExecute(Sender: TObject);
begin
  inherited;

  if Mounted() then
    begin
    SetStatusMsg(_('Refreshing...'));
    SDFilesystemTreeView1.RefreshNodes();
    SetStatusMsg('');
    end;

  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.actSelectAllExecute(Sender: TObject);
begin
  inherited;
  SDFilesystemListView1.SelectAll();
  SDFilesystemListView1.SetFocus();

end;

procedure TfrmFreeOTFEExplorerMain.actShowBootSectorExecute(Sender: TObject);
var
  dlg: TSDFATBootSectorPropertiesDialog;
begin
  dlg:= TSDFATBootSectorPropertiesDialog.Create(self);
  try
    dlg.Filesystem := TSDFilesystem_FAT(Filesystem);
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEExplorerMain.actStoreDirExecute(Sender: TObject);
begin
  inherited;
  PromptForAndImportDir(GetSelectedPath(Sender));

end;

procedure TfrmFreeOTFEExplorerMain.actStoreFileExecute(Sender: TObject);
begin
  inherited;
  PromptForAndImportFile(GetSelectedPath(Sender));

end;

procedure TfrmFreeOTFEExplorerMain.actCheckStatusBarExecute(Sender: TObject);
begin
  inherited;
  Settings.OptDisplayStatusbar := actCheckStatusBar.Checked;
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.actCheckAddressBarExecute(Sender: TObject);
begin
  inherited;
  Settings.OptDisplayAddressBar := actCheckAddressBar.Checked;
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.actCheckToolbarExplorerExecute(
  Sender: TObject);
begin
  inherited;
  Settings.OptDisplayToolbarExplorer := actCheckToolbarExplorer.Checked;
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.actCheckToolbarVolumeExecute(
  Sender: TObject);
begin
  inherited;
  Settings.OptDisplayToolbarVolume := actCheckToolbarVolume.Checked;
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.actCreateSubDirExecute(Sender: TObject);
var
  retval: boolean;
  dlg: TfrmNewDirDlg;
begin
  inherited;

  dlg := TfrmNewDirDlg.Create(self);
  try
    if (dlg.ShowModal() = mrOK) then
      begin
      retval := CreateSubDir(
                             GetSelectedPath(Sender),
                             dlg.DirName
                            );

      if retval then
        begin
        SDUMessageDlg(_('Folder created successfully'), mtInformation);
        end
      else
        begin
        SDUMessageDlg(_('Unable to create folder'+SDUCRLF+
                        SDUCRLF+
                        'Please ensure that there is enough free space available'),
                      mtError);
        end;

      actRefreshExecute(Sender);
      end;
      
  finally
    dlg.Free();
  end;
  
end;

procedure TfrmFreeOTFEExplorerMain.Dismount();
begin
  Dismount(#0);
end;

// Specify #0 as driveLetter to dismount all
procedure TfrmFreeOTFEExplorerMain.Dismount(driveLetter: char);
begin
  SDFilesystemListView1.Filesystem := nil;
  SDFilesystemTreeView1.Filesystem := nil;

  if (Filesystem <> nil) then
    begin
    Filesystem.Mounted := FALSE;
    Filesystem.Free();
    Filesystem := nil;
    end;

  if (PartitionImage <> nil) then
    begin
    PartitionImage.Mounted := FALSE;
    PartitionImage.Free();
    PartitionImage := nil
    end;

  if (driveLetter = #0) then
    begin
    OTFEFreeOTFE.DismountAll();
    end
  else
    begin
    OTFEFreeOTFE.Dismount(driveLetter);
    end;

  SetTitleCaption();
  SetStatusMsg('');
  EnableDisableControls();

end;

procedure TfrmFreeOTFEExplorerMain.MountPlaintextImage(filename: string; mountReadonly: boolean);
begin
  Dismount();

  PartitionImage := TSDPartitionImage_File.Create();
  TSDPartitionImage_File(PartitionImage).Filename := filename;
  PartitionImage.Mounted := TRUE;

  if not(PartitionImage.Mounted) then
    begin
    PartitionImage.Free();
    PartitionImage := nil;
    end;

  if (PartitionImage <> nil) then
    begin
    Filesystem := TSDFilesystem_FAT.Create();
    Filesystem.PartitionImage := PartitionImage;
    try
      Filesystem.Mounted := TRUE;
    except
      on E:EFileSystemNotRecognised do
        begin
        SDUMessageDlg(_('The filesystem used by this volume could not be recognised as either FAT12, FAT16 or FAT32.'), mtError);
        Dismount();
        end;
    end;
    end;

  if (Filesystem <> nil) then
    begin
    if Filesystem.Mounted then
      begin
      Filesystem.Readonly := mountReadonly;

      SetupControls();
      SetTitleCaption();
      end;
    end;

end;

procedure TfrmFreeOTFEExplorerMain.actCheckFilesystemExecute(Sender: TObject);
var
  allOK: boolean;
begin
  SetStatusMsg(_('Checking filesystem...'));
  try
    allOK := Filesystem.CheckFilesystem();
  finally
    SetStatusMsg('');
  end;

  if allOK then
    begin
    SDUMessageDlg(_('Filesystem OK'), mtInformation);
    end
  else
    begin
    Filesystem.Readonly := TRUE;
    SDUMessageDlg(
                  SDUParamSubstitute(
                                     _('Filesystem errors detected.'+SDUCRLF+
                                       SDUCRLF+
                                       'Please mount as a normal drive, and run chkdsk to correct.'+
                                       SDUCRLF+
                                       '%1 will continue in readonly mode'),
                                     [Application.Title]
                                    ),
                  mtError
                  );
    end;

end;

procedure TfrmFreeOTFEExplorerMain.actDeleteExecute(Sender: TObject);
var
  userConfirmed: boolean;
  promptMsg: WideString;
  item: TSDDirItem_FAT;
  i: integer;
  allOK: boolean;
  targetItems: TStringList;
begin
  inherited;

  targetItems:= TStringList.Create();
  try
    GetSelectedItems(Sender, targetItems);

    // Sanity check...
    for i:=0 to (targetItems.count - 1) do
      begin
      if (targetItems[i] = PATH_SEPARATOR) then
        begin
        // WHAT?!!!
        // The user wants to delete the *root* *directory*?!
        // I don't *think* so!!
        exit; // Bail out
        end;
      end;

    userConfirmed := FALSE;

    if (targetItems.Count = 0) then
      begin
      // Do nothing; userConfirmed already set to FALSE
      end
    else
      begin
      if (targetItems.Count = 1) then
        begin
        item := TSDDirItem_FAT.Create();
        try
          Filesystem.GetItem(targetItems[0], item);

          if item.IsFile then
            begin
            promptMsg := SDUParamSubstitute(
                                            _('Are you sure you want to delete ''%1''?'),
                                            [item.Filename]
                                           );
            end
          else
            begin
            promptMsg := SDUParamSubstitute(
                                            _('Are you sure you want to remove the folder ''%1'' and all its contents?'),
                                            [item.Filename]
                                           );
            end;
        finally
          item.Free();
        end;

        end
      else
        begin
        promptMsg := SDUParamSubstitute(
                                        _('Are you sure you want to delete these %1 items?'),
                                        [targetItems.Count]
                                       );
        end;

      userConfirmed := SDUConfirmYN(promptMsg);
      end;

    if userConfirmed then
      begin
      allOK := TRUE;
      for i:=0 to (targetItems.Count - 1) do
        begin
        allOK := Filesystem.DeleteFileOrDir(targetItems[i]);
        if not(allOK) then
          begin
          SDUMessageDlg(
                        SDUParamSubstitute(
                                           // Note: Windows Explorer states "files" here,
                                           //       even if it's a dir, so we do as well
                                           _('Cannot delete ''%1'': Cannot find the specified file.'+SDUCRLF+
                                             SDUCRLF+
                                             'Make sure you specify the correct path and file name.'),
                                            [ExtractFilename(targetItems[i])]
                                          ),
                                          mtError
                                         );
          break;
          end;
        end;

        if allOK then
          begin
          SDUMessageDlg(_('Deleted successfully'), mtInformation);
          end;

        // Refresh anyway, in case *some* but not all files were deleted
        actRefreshExecute(Sender);
      end;

  finally
    targetItems.Free()
  end;

end;

procedure TfrmFreeOTFEExplorerMain.actDismountExecute(Sender: TObject);
begin
  inherited;
  Dismount();
end;

procedure TfrmFreeOTFEExplorerMain.actExtractExecute(Sender: TObject);
var
  i: integer;
  extractToDir: string;
  extractFromPath: string;
  allOK: boolean;
  targetItems: TStringList;
  item: TSDDirItem_FAT;
  prevCursor: TCursor;
begin
  inherited;

  targetItems:= TStringList.Create();
  try
    GetSelectedItems(Sender, targetItems);

    if SDUSelectDirectory(
                       self.Handle,
                       _('Select location to extract to:'),
                       '',
                       extractToDir,
                       BIF_USENEWUI
                      ) then
      begin
      allOK := TRUE;

      SetStatusMsg(SDUParamSubstitute(_('Extracting to: %1'), [extractToDir]));

      prevCursor := Screen.Cursor;
      Screen.Cursor := crHourglass;
      try
        for i:=0 to (targetItems.Count - 1) do
          begin
          extractFromPath := targetItems[i];

          item := TSDDirItem_FAT.Create();
          try
            Filesystem.GetItem(extractFromPath, item);

            if item.IsFile then
              begin
              if not(ExtractFile(
                                 extractFromPath,
                                 IncludeTrailingPathDelimiter(extractToDir)+item.Filename
                                )) then
                begin
                allOK := FALSE;
                end;
              end
            else if (
                     item.IsDirectory and
                     (item.Filename <> DIR_CURRENT_DIR) and
                     (item.Filename <> DIR_PARENT_DIR)
                    ) then
              begin
              if not(ExtractDir(
                                extractFromPath,
                                IncludeTrailingPathDelimiter(extractToDir)+item.Filename
                               )) then
                begin
                allOK := FALSE;
                end;
              end;

          finally
            item.Free();
          end;

          end;
          
      finally
        Screen.Cursor := prevCursor;
      end;


      SetStatusMsg('');

      if allOK then
        begin
        SDUMessageDlg(_('Extraction completed successfully.'), mtInformation);
        end;

      end;

  finally
    targetItems.Free();
  end;

end;

procedure TfrmFreeOTFEExplorerMain.actFreeOTFENewExecute(Sender: TObject);
var
  prevMounted: string;
  newMounted: string;
  i: integer;
begin
  inherited;

  prevMounted := OTFEFreeOTFE.DrivesMounted;

  if not(OTFEFreeOTFE.CreateFreeOTFEVolumeWizard()) then
    begin
    if (OTFEFreeOTFE.LastErrorCode <> OTFE_ERR_USER_CANCEL) then
      begin
      SDUMessageDlg(_('FreeOTFE volume could not be created'), mtError);
      end;
    end
  else
    begin
    newMounted := OTFEFreeOTFE.DrivesMounted;

    // If the "drive letters" mounted have changed, the new volume was
    // automatically mounted; setup for this
    if (newMounted <> prevMounted) then
      begin
      for i:=1 to length(prevMounted) do
        begin
        Dismount(prevmounted[i]);
        end;

      if (newMounted <> '') then
        begin
        PostMountGUISetup(
                          OTFEFreeOTFE.GetVolFileForDrive(newMounted[1]),
                          newMounted[1]
                         );
        end;

      EnableDisableControls();
      end;

    SDUMessageDlg(
               _('FreeOTFE volume created successfully.'),
               mtInformation
              );
    end;

end;

procedure TfrmFreeOTFEExplorerMain.actListStyleExecute(Sender: TObject);
begin
  inherited;
  Settings.OptDisplayListViewStyle := TViewStyle(TMenuItem(Sender).Tag);
  EnableDisableControls();

end;

procedure TfrmFreeOTFEExplorerMain.actPlaintextMountFileExecute(
  Sender: TObject);
begin
  inherited;

  SDUOpenDialog_MountPlaintextImage.Filter     := FILE_FILTER_FLT_PLAINTEXTIMAGES;
  SDUOpenDialog_MountPlaintextImage.DefaultExt := FILE_FILTER_DFLT_PLAINTEXTIMAGES;

  SDUOpenDialog_MountPlaintextImage.Options := SDUOpenDialog_MountPlaintextImage.Options - [ofHideReadOnly];


  if SDUOpenDialog_MountPlaintextImage.Execute() then
    begin
    MountPlaintextImage(
                        SDUOpenDialog_MountPlaintextImage.Filename,
                        (ofReadOnly in SDUOpenDialog_MountPlaintextImage.Options)
                       );
    end;
end;

procedure TfrmFreeOTFEExplorerMain.actPlaintextNewExecute(Sender: TObject);
var
  volSizeDlg: TfrmNewVolumeSize;
  mr: integer;
  allOK: boolean;
  userCancel: boolean;
  filename: string;
  tmpPartitionImage: TSDPartitionImage_File;
  tmpFilesystem: TSDFilesystem_FAT;
begin
  allOK := TRUE;

  if allOK then
    begin
    allOK := SDUWarnYN(
                  _('This function will create an UNENCRYPTED disk image.'+SDUCRLF+
                    SDUCRLF+
                    'If you would like to create an ENCRYPTED disk image, please click "No" below, and then select "File | New..."'+SDUCRLF+
                    SDUCRLF+
                    'Are you sure you with to create an UNENCRYPTED disk image?')
                 );
    end;

  // Create the plaintext image file
  if allOK then
    begin
    volSizeDlg:= TfrmNewVolumeSize.Create(nil);
    try
      volSizeDlg.Filter     := FILE_FILTER_FLT_PLAINTEXTIMAGES;
      volSizeDlg.DefaultExt := FILE_FILTER_DFLT_PLAINTEXTIMAGES;

      mr := volSizeDlg.ShowModal;
      if (mr <> mrOK) then
        begin
        allOK := FALSE;
        end
      else
        begin
        filename := volSizeDlg.Filename;
        if not(SDUCreateLargeFile(filename, volSizeDlg.VolumeSize, TRUE, userCancel)) then
          begin
          if not(userCancel) then
            begin
            SDUMessageDlg(_('An error occured while trying to create your volume file'), mtError, [mbOK], 0);
            end;

          allOK := FALSE;
          end;
        end;

    finally
      volSizeDlg.Free();
    end;

    end;

  // Format the plaintext image file
  if allOK then
    begin
    tmpPartitionImage := TSDPartitionImage_File.Create();
    try
      tmpPartitionImage.Filename := filename;
      tmpPartitionImage.Mounted := TRUE;

      if not(tmpPartitionImage.Mounted) then
        begin
        SDUMessageDlg('Volume could be mounted, but not mounted as a partition image?!', mtError);
        allOK := FALSE;
        end
      else
        begin
        tmpFilesystem := TSDFilesystem_FAT.Create();
        try
          tmpFilesystem.PartitionImage := tmpPartitionImage;
          tmpFilesystem.Format();
        finally
          tmpFilesystem.Free();
        end;
        
        tmpPartitionImage.Mounted := FALSE;
        end;

    finally
      tmpPartitionImage.Free();
    end;

    end;

  // Mount the plaintext image file
  if allOK then
    begin
    MountPlaintextImage(filename, FALSE);
    end;

end;


procedure TfrmFreeOTFEExplorerMain.actItemPropertiesExecute(Sender: TObject);
var
  dlgFile: TfrmPropertiesDialog_File;
  dlgDirectory: TfrmPropertiesDialog_Directory;
  dlgMultiple: TfrmPropertiesDialog_Multiple;
  targetItems: TStringList;
begin
  inherited;

  targetItems:= TStringList.Create();
  try
    GetSelectedItems(Sender, targetItems);

    if (targetItems.Count = 0) then
      begin
      // Do nothing
      end
    else if (targetItems.Count > 1) then
      begin
      // Show properties as single directory...
      dlgMultiple:= TfrmPropertiesDialog_Multiple.Create(self);
      try
        dlgMultiple.Filesystem := Filesystem;
        dlgMultiple.MultipleItems.Assign(targetItems);
        dlgMultiple.ParentDir := GetSelectedPath(Sender);
        dlgMultiple.ShowModal();
      finally
        dlgMultiple.Free();
      end;

      end
    else if (targetItems.Count = 1) then
      begin
      if Filesystem.FileExists(targetItems[0]) then
        begin
        // Show properties as single file...
        dlgFile:= TfrmPropertiesDialog_File.Create(self);
        try
          dlgFile.Filesystem := Filesystem;
          dlgFile.PathAndFilename := targetItems[0];
          dlgFile.ShowModal();
        finally
          dlgFile.Free();
        end;

        end
      else
        begin
        // Show properties as single directory...
        dlgDirectory:= TfrmPropertiesDialog_Directory.Create(self);
        try
          dlgDirectory.Filesystem := Filesystem;
          dlgDirectory.PathAndFilename := targetItems[0];
          dlgDirectory.ShowModal();
        finally
          dlgDirectory.Free();
        end;

        end;
      end;

  finally
    targetItems.Free();
  end;

end;

procedure TfrmFreeOTFEExplorerMain.actUpDirExecute(Sender: TObject);
begin
  inherited;

  SDFilesystemTreeView1.Selected := SDFilesystemTreeView1.Selected.Parent;
end;

procedure TfrmFreeOTFEExplorerMain.FormShow(Sender: TObject);
begin
  // Setup so *we* draw this panel, as we want the little image displayed
//  StatusBar.Panels[STATUSBAR_PANEL_LOCATION].Style := psOwnerDraw;

  SetStatusMsg();

  SDUCenterControl(lblFolder, ccVertical);
  SDUCenterControl(edPath, ccVertical);
  SDUCenterControl(pbGo, ccVertical);

  EnableDisableControls();
end;


function TfrmFreeOTFEExplorerMain.DefaultStatusMsg(): string;
var
  fsFreeSpace: ULONGLONG;
//  fsSize: ULONGLONG;
  dispMsg: string;
  selectedItem: TSDDirItem;
  size: string;
  fileType: string;
  date: string;
  sizeKB: integer;
  itemsInSelected: integer;
begin
  // Fallback msg; anything other than ''
  dispMsg := _('Ready.');

  if not(Mounted())then
    begin
    dispMsg := _('Ready to mount volume...');
    end
  else
    begin
    if (SDFilesystemListView1.SelCount <= 0) then
      begin
      fsFreeSpace := Filesystem.FreeSpace;
  //    fsSize := Filesystem.Size;

      itemsInSelected := SDFilesystemListView1.Items.Count;
      if SDFilesystemListView1.ShowParentDir then
        begin
        dec(itemsInSelected);
        end;

      dispMsg := SDUParamSubstitute(
                                    _('%1 objects (Disk free space: %2)'),
                                    [
                                     itemsInSelected,
  //                                   SDUFormatAsBytesUnits(fsFreeSpace),
                                     // MS Explorer only displays to 1 decimal place
                                     SDUFormatUnits(
                                                    fsFreeSpace,
                                                    SDUUnitsStorageToTextArr(),
                                                    UNITS_BYTES_MULTIPLIER,
                                                    1
                                                   )
                                    ]
                                   );


  {
      dispMsg := SDUParamSubstitute(
                                   _('Free Space: %1; Total size: %2'),
                                   [
  //                                  SDUFormatAsBytesUnits(fsFreeSpace),
                                    // MS Explorer only displays to 1 decimal place
                                    SDUFormatUnits(
                                                   fsFreeSpace,
                                                   SDUUnitsStorageToTextArr(),
                                                   UNITS_BYTES_MULTIPLIER,
                                                   1
                                                  ),
  //                                  SDUFormatAsBytesUnits(fsSize)
                                    // MS Explorer only displays to 1 decimal place
                                    SDUFormatUnits(
                                                   fsSize,
                                                   SDUUnitsStorageToTextArr(),
                                                   UNITS_BYTES_MULTIPLIER,
                                                   1
                                                  )
                                    ]
                                   );
  }
      end
    else if (SDFilesystemListView1.SelCount = 1) then
      begin
      selectedItem := SDFilesystemListView1.DirItem[SDFilesystemListView1.SelectedIdx];
      if selectedItem.IsFile then
        begin
        // Always display size in KB
        sizeKB := (selectedItem.Size div BYTES_IN_KILOBYTE);
        // Round up, like MS Explorer does...
        if ((selectedItem.Size mod BYTES_IN_KILOBYTE) > 0) then
          begin
          sizeKB := sizeKB + 1;
          end;
        // Format with thousands separator and KB units
        size := SDUIntToStrThousands(sizeKB) + ' ' + UNITS_STORAGE_KB;

        fileType := SDUGetFileType_Description(selectedItem.Filename);
        date := DateTimeToStr(TimeStampToDateTime(selectedItem.TimestampLastModified));

        dispMsg := SDUParamSubstitute(
                                      _('Type: %1 Date Modified: %2 Size: %3'),
                                      [
                                       fileType,
                                       date,
                                       size
                                      ]
                                     );
        end
      else
        begin
        dispMsg := SDUParamSubstitute(
                                      _('%1 object selected'),
                                      [SDFilesystemListView1.SelCount]
                                     );
        end;

      end
    else
      begin
      dispMsg := SDUPluralMsg(
                              SDFilesystemListView1.SelCount,
                              [
                               SDUParamSubstitute(
                                                  _('%1 object selected'),
                                                  [SDFilesystemListView1.SelCount]
                                                 ),
                               SDUParamSubstitute(
                                                  _('%1 objects selected'),
                                                  [SDFilesystemListView1.SelCount]
                                                 )
                              ]
                             );
      end;
    end;

  Result := dispMsg;
end;

function TfrmFreeOTFEExplorerMain.SelectedItemsStatusMsg(): string;
var
  currItem: TSDDirItem;
  totalSize: ULONGLONG;
  sumAllItems: boolean;
  i: integer;
  onlyDirsSelected: boolean;
  retval: string;
begin
  retval := '';

  // If the only things which are *selected* are directories, return blank
  // If one or more items are selected, return their sum total size
  // If nothing is selected, return the sum total size of all items

  sumAllItems := (SDFilesystemListView1.SelCount <= 0);

  totalSize := 0;
  onlyDirsSelected := TRUE;
  for i:=0 to (SDFilesystemListView1.Items.Count - 1) do
    begin
    currItem:= SDFilesystemListView1.DirItem[i];

    if (
        SDFilesystemListView1.Items[i].Selected and
        currItem.IsFile
       ) then
      begin
      onlyDirsSelected := FALSE;
      end;

    if (
        (
         SDFilesystemListView1.Items[i].Selected or
         sumAllItems
        ) and
        currItem.IsFile
       ) then
      begin
      totalSize := totalSize + currItem.Size;
      end;

    end;

  if (
      (SDFilesystemListView1.SelCount > 0) and
      onlyDirsSelected
     ) then
    begin
    // Do nothing - already set to ''
    end
  else
    begin
    retval := SDUFormatUnits(
                             totalSize,
                             SDUUnitsStorageToTextArr(),
                             UNITS_BYTES_MULTIPLIER,
                             2
                            );
    end;

  Result := retval;
end;

procedure TfrmFreeOTFEExplorerMain.SDFilesystemListView1SelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  SetStatusMsg();
end;

procedure TfrmFreeOTFEExplorerMain.SDFilesystemTreeView1Change(Sender: TObject;
  Node: TTreeNode);
var
  i: integer;
begin
  edPath.text := SDFilesystemTreeView1.PathToNode(Node);

  if (SDFilesystemTreeView1.Selected <> nil) then
    begin
    // Delete all after the current point
    for i:=(FNavigateHistory.Count - 1) downto (FNavigateIdx+1) do
      begin
      FNavigateHistory.Delete(i);
      end;

    FNavigateHistory.Append(SDFilesystemTreeView1.PathToNode(SDFilesystemTreeView1.Selected));

    while (FNavigateHistory.Count > MAX_BACKFORWARD_NAV_TOTALITEMS) do
      begin
      FNavigateHistory.Delete(0);
      end;

    FNavigateIdx := (FNavigateHistory.Count - 1);
    end;

  // This is a bit klunky!
  // Because the popup context menu has shortcut keys, when the treeview is
  // selected and one of these shortcut keys is pressed, the relevant context
  // menuitem's event will fire - and it'll look like the context menuitem was
  // selected by the user.
  // As a result, pmTreeView.Tag won't have been setup to reflect the selected
  // treeview node.
  // Part of the solution to prevent this from happening is set the .Tag of the
  // context menu everytime a different node is selected
  // The other part of the solution is to detect when the treeview's context
  // menu closes, and reset pmTreeView.Tag back to the currently selected node
  //
  // !!!!!!!!!!!!!
  // WARNING:
  // This still has a bug in it; if the user displays the context menu for a
  // node *other* than the one currently selected, cancels the popup menu by
  // pressing <ESCAPE>, and then uses a shortcut key to do something - the
  // node used for the popup context menu will be acted on - not the currently
  // selected node!
  // xxx - lplp - TODO: FIX THIS!
  // !!!!!!!!!!!!!
  pmTreeView.Tag := integer(SDFilesystemTreeView1.Selected);

  EnableDisableControls();
  SetStatusMsg();
end;

procedure TfrmFreeOTFEExplorerMain.actNavigateBackExecute(Sender: TObject);
begin
  if (FNavigateIdx > 0) then
    begin
    NavigateToHistoryIdx(FNavigateIdx-1);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.actNavigateForwardExecute(Sender: TObject);
begin
  if (FNavigateIdx < (FNavigateHistory.Count - 1)) then
    begin
    NavigateToHistoryIdx(FNavigateIdx+1);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.actOptionsExecute(Sender: TObject);
var
  dlg: TfrmOptions_FreeOTFEExplorer;
begin
  inherited;

  dlg := TfrmOptions_FreeOTFEExplorer.Create(self);
  try
    dlg.OTFEFreeOTFEBase := OTFEFreeOTFE;
    if (dlg.ShowModal() = mrOK) then
      begin
      ReloadSettings();
      EnableDisableControls();
      end;

  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEExplorerMain.NavigateToHistoryIdx(idx: integer);
var
  prev: TStringList;
begin
  prev:= TStringList.Create();
  try
    prev.Assign(FNavigateHistory);

    SDFilesystemTreeView1.GoToPath(FNavigateHistory[idx], FALSE);

    FNavigateHistory.Assign(prev);
    FNavigateIdx := idx;

  finally
    prev.Free();
  end;

  // EnableDisableControls(...) call required here as FNavigateHistory
  // was updated
  EnableDisableControls();

end;

procedure TfrmFreeOTFEExplorerMain.SDFilesystemTreeView1ContextPopup(
  Sender: TObject; MousePos: TPoint; var Handled: Boolean);
var
  hitTestTreeNode: TTreeNode;
begin
  inherited;

  hitTestTreeNode := TTreeView(sender).GetNodeAt(MousePos.X, MousePos.Y);

  if (hitTestTreeNode <> nil) then
    begin
    mnuTreeViewExpand.Visible := (
                                  (SDFilesystemTreeView1.SelectionCount = 1) and
                                  not(SDFilesystemTreeView1.Selected.Expanded)
                                 );
    mnuTreeViewCollapse.Visible := (
                                    (SDFilesystemTreeView1.SelectionCount = 1) and
                                    SDFilesystemTreeView1.Selected.Expanded
                                   );

    pmTreeView.Tag := integer(hitTestTreeNode);

    // This *should* enable/disable controls taking into account the node the
    // context menu is being displayed for.
    // But since all nodes are currently treated the same, we can get away
    // with just calling EnableDisableControls(...) for now
    // xxx - lplp - fix this
    //EnableDisableControls(FHitContextTreeNode);
    EnableDisableControls();
    
    end
  else
    begin
    // No node under mouse - do not display popup
    Handled := TRUE;
    end;
    
end;


procedure TfrmFreeOTFEExplorerMain.SDFilesystemListView1Change(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
  inherited;
  EnableDisableControls();

end;

procedure TfrmFreeOTFEExplorerMain.SDFilesystemListView1Enter(Sender: TObject);
begin
  inherited;
  LastFocussed := lfListView;
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.SDFilesystemTreeView1Enter(Sender: TObject);
begin
  inherited;
  LastFocussed := lfTreeView;
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.SDUDropFilesTreeViewItemsDrop(
  Sender: TObject; DropItems: TStringList; DropPoint: TPoint);
var
  droppedOnNode: TTreeNode;
  importToPath: WideString;
begin
  inherited;

  // If the user dropped on a tree node, import to that path. Otherwise,
  // import to the currently selected node
  droppedOnNode := SDFilesystemTreeView1.GetNodeAt(DropPoint.X, DropPoint.Y);
  if (droppedOnNode = nil) then
    begin
    droppedOnNode := SDFilesystemTreeView1.Selected;
    end;

  if (droppedOnNode <> nil) then
    begin
    importToPath := SDFilesystemTreeView1.PathToNode(droppedOnNode);
    ConfirmForAndImportMultiple(DropItems, importToPath);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.SDUDropFilesListViewItemsDrop(
  Sender: TObject; DropItems: TStringList; DropPoint: TPoint);
var
  importToPath: WideString;
  droppedOnItem: TListItem;
begin
  inherited;

  droppedOnItem := SDFilesystemListView1.GetItemAt(DropPoint.X, DropPoint.Y);

  importToPath := SDFilesystemListView1.Path;
  if (droppedOnItem <> nil) then
    begin
    if SDFilesystemListView1.DirItem[droppedOnItem.Index].IsDirectory then
      begin
      importToPath := IncludeTrailingPathDelimiter(SDFilesystemListView1.Path)+SDFilesystemListView1.DirItem[droppedOnItem.Index].Filename;
      end;
    end;

  if (importToPath <> '') then
    begin
    ConfirmForAndImportMultiple(DropItems, importToPath);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.ConfirmForAndImportMultiple(srcItems: TStringList; importToPath: WideString);
var
  confirmMsg: WideString;
begin
  if (srcItems.Count = 1) then
    begin
    confirmMsg := SDUParamSubstitute(
                                     _('Are you sure you wish to store ''%1'' to:'+SDUCRLF+
                                       SDUCRLF+
                                       '  %2'),
                                     [
                                      ExtractFilename(srcItems[0]),
                                      importToPath
                                     ]
                                    );
    end
  else
    begin
    confirmMsg := SDUParamSubstitute(
                                     _('Are you sure you wish to store the %1 items dropped to:'+SDUCRLF+
                                       SDUCRLF+
                                       '%2'),
                                     [
                                      srcItems.Count,
                                      importToPath
                                     ]
                                    );
    end;

  if SDUConfirmYN(confirmMsg) then
    begin
    ImportMultiple(srcItems, importToPath, TRUE);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.RecaptionToolbarAndMenuIcons();
begin
  inherited;
  
  // Change toolbar captions to shorter captions
  tbbNew.Caption                := RS_TOOLBAR_CAPTION_NEW;
  tbbMountFile.Caption          := RS_TOOLBAR_CAPTION_MOUNTFILE;
  tbbDismount.Caption           := RS_TOOLBAR_CAPTION_DISMOUNT;

  tbbNavigateBack.Caption       := RS_TOOLBAR_CAPTION_BACK;
  tbbNavigateForward.Caption    := RS_TOOLBAR_CAPTION_FORWARD;
  tbbUp.Caption                 := RS_TOOLBAR_CAPTION_UP;
  tbbMoveTo.Caption             := RS_TOOLBAR_CAPTION_MOVETO;
  tbbCopyTo.Caption             := RS_TOOLBAR_CAPTION_COPYTO;
  tbbDelete.Caption             := RS_TOOLBAR_CAPTION_DELETE;
  tbbViews.Caption              := RS_TOOLBAR_CAPTION_VIEWS;
  tbbExtract.Caption            := RS_TOOLBAR_CAPTION_EXTRACT;
  tbbStore.Caption              := RS_TOOLBAR_CAPTION_STORE;
  tbbItemProperties.Caption     := RS_TOOLBAR_CAPTION_ITEMPROPERTIES;

  mnuToolbarStoreFile.Caption   := RS_TOOLBAR_MNU_CAPTION_STORE_FILE;
  mnuToolbarStoreDir.Caption    := RS_TOOLBAR_MNU_CAPTION_STORE_DIR;

  // Toolbar hints...
  tbbNew.Hint                := RS_TOOLBAR_HINT_NEW;
  tbbMountFile.Hint          := RS_TOOLBAR_HINT_MOUNTFILE;
  tbbDismount.Hint           := RS_TOOLBAR_HINT_DISMOUNT;

  tbbNavigateBack.Hint       := RS_TOOLBAR_HINT_BACK;
  tbbNavigateForward.Hint    := RS_TOOLBAR_HINT_FORWARD;
  tbbUp.Hint                 := RS_TOOLBAR_HINT_UP;
  tbbMoveTo.Hint             := RS_TOOLBAR_HINT_MOVETO;
  tbbCopyTo.Hint             := RS_TOOLBAR_HINT_COPYTO;
  tbbDelete.Hint             := RS_TOOLBAR_HINT_DELETE;
  tbbViews.Hint              := RS_TOOLBAR_HINT_VIEWS;
  tbbExtract.Hint            := RS_TOOLBAR_HINT_EXTRACT;
  tbbStore.Hint              := RS_TOOLBAR_HINT_STORE;
  tbbItemProperties.Hint     := RS_TOOLBAR_HINT_ITEMPROPERTIES;

  mnuToolbarStoreFile.Hint   := RS_TOOLBAR_MNU_HINT_STORE_FILE;
  mnuToolbarStoreDir.Hint    := RS_TOOLBAR_MNU_HINT_STORE_DIR;

end;

procedure TfrmFreeOTFEExplorerMain.SetIconListsAndIndexes();
begin
  inherited;

  if Settings.OptDisplayToolbarVolumeLarge then
    begin
    ToolbarVolume.Images := ilToolbarIcons_Large;

    tbbNew.ImageIndex                := FIconIdx_Large_New;
    tbbMountFile.ImageIndex          := FIconIdx_Large_MountFile;
    tbbDismount.ImageIndex           := FIconIdx_Large_Dismount;
    end
  else
    begin
    ToolbarVolume.Images := ilToolbarIcons_Small;

    tbbNew.ImageIndex                := FIconIdx_Small_New;
    tbbMountFile.ImageIndex          := FIconIdx_Small_MountFile;
    tbbDismount.ImageIndex           := FIconIdx_Small_Dismount;
    end;
    
  if Settings.OptDisplayToolbarExplorerLarge then
    begin
    ToolbarExplorer.Images := ilToolbarIcons_Large;

    tbbNavigateBack.ImageIndex       := FIconIdx_Large_Back;
    tbbNavigateForward.ImageIndex    := FIconIdx_Large_Forward;
    tbbUp.ImageIndex                 := FIconIdx_Large_Up;
    tbbMoveTo.ImageIndex             := FIconIdx_Large_MoveTo;
    tbbCopyTo.ImageIndex             := FIconIdx_Large_CopyTo;
    tbbDelete.ImageIndex             := FIconIdx_Large_Delete;
    tbbViews.ImageIndex              := FIconIdx_Large_Views;
    tbbExtract.ImageIndex            := FIconIdx_Large_Extract;
    tbbStore.ImageIndex              := FIconIdx_Large_Store;
    tbbItemProperties.ImageIndex     := FIconIdx_Large_ItemProperties;
    end
  else
    begin
    ToolbarExplorer.Images := ilToolbarIcons_Small;

    tbbNavigateBack.ImageIndex       := FIconIdx_Small_Back;
    tbbNavigateForward.ImageIndex    := FIconIdx_Small_Forward;
    tbbUp.ImageIndex                 := FIconIdx_Small_Up;
    tbbMoveTo.ImageIndex             := FIconIdx_Small_MoveTo;
    tbbCopyTo.ImageIndex             := FIconIdx_Small_CopyTo;
    tbbDelete.ImageIndex             := FIconIdx_Small_Delete;
    tbbViews.ImageIndex              := FIconIdx_Small_Views;
    tbbExtract.ImageIndex            := FIconIdx_Small_Extract;
    tbbStore.ImageIndex              := FIconIdx_Small_Store;
    tbbItemProperties.ImageIndex     := FIconIdx_Small_ItemProperties;
    end;

end;

procedure TfrmFreeOTFEExplorerMain.SetupToolbarFromSettings();

  procedure SortToolbar(processToolbar: TToolbar);
  var
    toolbarWidth: integer;
    i: integer;
  begin
    processToolbar.Height       := processToolbar.Images.Height + TOOLBAR_ICON_BORDER;
    processToolbar.ButtonHeight := processToolbar.Images.Height;
    processToolbar.ButtonWidth  := processToolbar.Images.Width;


  // Turning captions on can cause the buttons to wrap if the window isn't big
  // enough.
  // This looks pretty poor, so resize the window if it's too small
  toolbarWidth := 0;
  for i:=0 to (processToolbar.ButtonCount - 1) do
    begin
    toolbarWidth := toolbarWidth + processToolbar.Buttons[i].Width;
    end;
  if (toolbarWidth > self.Width) then
    begin
    self.Width := toolbarWidth;
    processToolbar.width := self.Width;
    end;
  // Adjusting the width to the sum of the toolbar buttons doens't make it wide
  // enough to prevent wrapping (presumably due to window borders); nudge the
  // size until it does
  // (Crude, but effective)
  while (processToolbar.RowCount > 1) do
    begin
    self.Width := self.Width + 10;
    processToolbar.width := self.Width;
    end;

  end;

begin
  SetIconListsAndIndexes();

  // Visible/invisible are set in EnableDisableControls()

  // Toolbar captions...
  if Settings.OptDisplayToolbarVolumeLarge then
    begin
    ToolBarVolume.ShowCaptions := Settings.OptDisplayToolbarVolumeCaptions;
    end
  else
    begin
    ToolBarVolume.ShowCaptions :=  FALSE;
    end;

  // Toolbar captions...
  if Settings.OptDisplayToolbarExplorerLarge then
    begin
    ToolBarExplorer.ShowCaptions := Settings.OptDisplayToolbarExplorerCaptions;
    end
  else
    begin
    ToolBarExplorer.ShowCaptions :=  FALSE;
    end;


  ToolBarExplorer.visible := FALSE;
  SortToolbar(ToolBarVolume);

  ToolBarVolume.visible := FALSE;
  SortToolbar(ToolBarExplorer);

  ToolBarVolume.Visible   := Settings.OptDisplayToolbarVolume;
  ToolBarExplorer.Visible := Settings.OptDisplayToolbarExplorer;

end;


procedure TfrmFreeOTFEExplorerMain.FormCreate(Sender: TObject);
var
  goIcon: TIcon;
  goBitmap: TBitmap;
//  sysMagGlassIcon: TIcon;
begin
  OTFEFreeOTFEBase := TOTFEFreeOTFEDLL.Create(nil);

  Settings:= TFreeOTFEExplorerSettings.Create();
  Settings.Load();

  inherited;

  PartitionImage := nil;
  Filesystem     := nil;

  FNavigateHistory := TStringList.Create();
  FNavigateIdx := -1;

  actListStyleIcons.Tag      := ord(vsIcon);
  actListStyleSmallIcons.Tag := ord(vsSmallIcon);
  actListStyleList.Tag       := ord(vsList);
  actListStyleDetails.Tag    := ord(vsReport);

  // Hide functionality not yet implemented...
  // xxx - lplp - implement this!
  tbbMoveTo.visible := FALSE;
  tbbCopyTo.visible := FALSE;
  ToolButton1.visible := FALSE;

  // Set the actions on the TreeView's *context* *menuitems* to nil.
  // The act... actionitem event will still be called, but because of this, the
  // sender will be the popup's TMenuItem instead of the action item
  // This tells us to use the TTreeNode stored in the TreeView context menu's
  // .tag property when determining what dir to carry out the action on.
  //
  // !!!!!!!!!!!!!!
  // WARNING
  // !!!!!!!!!!!!!!
  // As a consequence of this, EnableDisableControls(...) must *explicitly* set
  // enabled/disabled on these menuitems - as well as the actionitems they
  // would otherwise use!
  mnuTreeViewExtract.Action        := nil;
  mnuTreeViewStoreFile.Action      := nil;
  mnuTreeViewStoreDir.Action       := nil;
  mnuTreeViewCreateSubDir.Action   := nil;
  mnuTreeViewDelete.Action         := nil;
  mnuTreeViewItemProperties.Action := nil;

  // Add standard Windows "Go" icon to "Go" button
  goIcon := TIcon.Create();
  goBitmap:= TBitmap.Create();
  try
    if SDULoadDLLIcon(
                      DLL_SHELL32,
                      TRUE,
                      DLL_SHELL32_GO_ICON,
                      goIcon
                     ) then
      begin
      // Must specify 16x16 explicitly as the icon loaded is always 32x32
      SDUConvertIconToBitmap(goIcon, 16, 16, goBitmap, nil);
      pbGO.Glyph.Assign(goBitmap);
      end;

  finally
    goBitmap.Free();
    goIcon.Free();
  end;

{
  // Overlay system standard magnifying glass icon on top of main icon, if
  // possible
  sysMagGlassIcon := TIcon.Create();
  try
    if SDULoadDLLIcon(
                      DLL_SHELL32,
                      FALSE,
                      DLL_SHELL32_MAGNIFYING_GLASS,
                      sysMagGlassIcon
                     ) then
      begin
      SDUImageFlip(sysMagGlassIcon, ifHorizontal);
      SDUOverlayIcon(Application.Icon, sysMagGlassIcon);
      end;

  finally
    sysMagGlassIcon.Free();
  end;
}

  OTFEFreeOTFE.ExeDir := ExtractFilePath(Application.ExeName);

  // We set these to invisible so that if they're disabled by the user
  // settings, it doens't flicker on them off
  ToolBarVolume.Visible := FALSE;
  ToolBarExplorer.Visible := FALSE;
  pnlAddressBar.Visible := FALSE;

  // Give the user a clue
  ToolBarVolume.ShowHint := TRUE;
  ToolBarExplorer.ShowHint := TRUE;

  ToolBarVolume.Indent := 5;
  ToolBarExplorer.Indent := 5;

  // Cosmetic tweak - when the user rightclicks on a node, this will make it
  // appear selected while the context menu is displayed - BUT WITHOUT FIRING
  // A TREEVIEW OnChange EVENT. After the context menu disappears, the
  // previously selected node appears selected
  SDFilesystemTreeView1.RightClickSelect := TRUE;

end;

procedure TfrmFreeOTFEExplorerMain.FormDestroy(Sender: TObject);
begin
  inherited;

  FNavigateHistory.Free();

  // We save settings here, in case the user changed any of the toolbar
  // visible/invisible, etc settings
  // Note that if the user hasn't configured a location to save their settings,
  // this save will have no effect
  Settings.Save();
  Settings.Free();

  OTFEFreeOTFE.Free();

end;

procedure TfrmFreeOTFEExplorerMain.FormResize(Sender: TObject);
begin
  SizeStatusBar();
end;

procedure TfrmFreeOTFEExplorerMain.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var
  textRect: TRect;
begin
  if (Panel.Index <> STATUSBAR_PANEL_LOCATION) then
    begin
    inherited;
    end
  else
    begin
    if (Panel.Text <> '') then
      begin
      ImageList_StatusBar.Draw(StatusBar.Canvas, Rect.Left, Rect.Top, IMGLIST_IDX_FREEOTFE);

      textRect := Rect;
      textRect.Left := textRect.Left + ImageList_StatusBar.width;

      // +2 here to give a bit of a gap between the image and text
      // +1 here so it's at the same height as the text in other panels
      StatusBar.Canvas.TextRect(
                                textRect,
                                (textRect.Left + 2),
                                (textRect.Top + 1),
                                Panel.Text
                               );
      end;
    end;
end;

procedure TfrmFreeOTFEExplorerMain.PromptForAndImportFile(importToPath: WideString);
begin
  if SDUOpenDialog_Store.Execute then
    begin
    ImportFile(SDUOpenDialog_Store.Filename, importToPath, TRUE);
    end;

end;

function TfrmFreeOTFEExplorerMain.ImportFile(srcItem: WideString; importToPath: WideString; showMsgOnSuccess: boolean): boolean;
var
  allOK: boolean;
  item: TSDDirItem_FAT;
  CreationTime: TFileTime;
  LastAccessTime: TFileTime;
  LastWriteTime: TFileTime;
  newDateTime: string;
  opCompletedOK: boolean;
  prevCursor: TCursor;
begin
  allOK:= TRUE;
  
  if allOK then
    begin
    item:= TSDDirItem_FAT.Create();
    try
      if Filesystem.GetItem(
                 IncludeTrailingPathDelimiter(importToPath)+
                 ExtractFilename(srcItem),
                 item
                ) then
        begin
        if item.IsDirectory then
          begin
          SDUMessageDlg(
                        SDUParamSubstitute(
                                           _('A directory called ''%1'' already exists'),
                                           [ExtractFilename(srcItem)]
                                          ),
                        mtError
                       );
          allOK := FALSE;
          end
        else if item.IsFile then
          begin
          newDateTime:= '???';
          if SDUFileTimestamps(
                               srcItem,
                               CreationTime,
                               LastAccessTime,
                               LastWriteTime
                              ) then
            begin
            newDateTime := DateTimeToStr(SDUFileTimeToDateTime(LastWriteTime));
            end;

          allOK := SDUConfirmYN(
                                  SDUParamSubstitute(
                                            _('This folder already contains a file named ''%1''.'+SDUCRLF+
                                              SDUCRLF+
                                              'Would you like to replace the existing file'+SDUCRLF+
                                              SDUCRLF+
                                              '  %2'+SDUCRLF+
                                              '  modified: %3'+SDUCRLF+
                                              SDUCRLF+
                                              'with this one?'+SDUCRLF+
                                              SDUCRLF+
                                              '  %4'+SDUCRLF+
                                              '  modified: %5'),
                                           [
                                            ExtractFilename(srcItem),
                                            SDUFormatAsBytesUnits(item.Size),
                                            DateTimeToStr(TimeStampToDateTime(item.TimestampLastModified)),
                                            SDUFormatAsBytesUnits(SDUGetFileSize(srcItem)),
                                            newDateTime
                                           ]
                                          ));
          end;
        end;

    finally
      item.Free();
    end;

    end;

    if allOK then
    begin
      prevCursor := Screen.Cursor;
      Screen.Cursor := crHourglass;
      try
        opCompletedOK := StoreFile(importToPath, srcItem)
      finally
        Screen.Cursor := prevCursor;
      end;

      if opCompletedOK then
        begin
        if showMsgOnSuccess then
          begin
          SDUMessageDlg(_('File stored successfully'), mtInformation);
          end;
        end
      else
        begin
        allOK := FALSE;
        SDUMessageDlg(
                      _('Unable to store file'+SDUCRLF+
                        SDUCRLF+
                        'Please ensure that there is enough free space available'),
                      mtError
                     );
        end;

      // Refresh regardless
      actRefreshExecute(nil);
    end;

  Result := allOK;
end;

function TfrmFreeOTFEExplorerMain.StoreFile(path: WideString; fileToStore: string): boolean;
var
  item: TSDDirItem_FAT;
  retval: boolean;
  fileStream: TFileStream;
  CreationTime: TFileTime;
  LastAccessTime: TFileTime;
  LastWriteTime: TFileTime;
  fileAttrs: integer;
begin
  SetStatusMsg(SDUParamSubstitute(_('Storing: %1...'), [ExtractFilename(fileToStore)]));
  
  item:= TSDDirItem_FAT.Create();
  fileStream := TFileStream.Create(fileToStore, (fmOpenRead or fmShareDenyNone));
  try
    item.Filename := ExtractFilename(fileToStore);
    item.FilenameDOS := '';  // Set to '' to autogenerate DOS 8.3 filename

    item.IsFile := TRUE;  // *VERY* IMPORTANT!!!

    item.Size := SDUGetFileSize(fileToStore);

    if SDUFileTimestamps(fileToStore, CreationTime, LastAccessTime, LastWriteTime) then
      begin
      item.TimestampCreation     := SDUFileTimeToTimeStamp(CreationTime);
      item.DatestampLastAccess   := SDUFileTimeToDateTime(LastAccessTime);
      item.TimestampLastModified := SDUFileTimeToTimeStamp(LastWriteTime);
      end
    else
      begin
      item.TimestampCreation     := DateTimeToTimeStamp(now);
      item.DatestampLastAccess   := Now;
      item.TimestampLastModified := DateTimeToTimeStamp(now);
      end;

// Turn off useless hints about FileCtrl.pas being platform specific
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}
    fileAttrs:= FileGetAttr(fileToStore);
    if (fileAttrs <> -1) then
      begin
      item.IsReadonly := (fileAttrs and faReadOnly) = faReadOnly;
      item.IsArchive  := (fileAttrs and faArchive) = faArchive;
      item.IsHidden   := (fileAttrs and faHidden) = faHidden;
      item.IsSystem   := (fileAttrs and faSysFile) = faSysFile;
      end;
{$WARN UNIT_PLATFORM ON}
{$WARN SYMBOL_PLATFORM ON}

    retval := Filesystem.StoreFileOrDir(path, item, fileStream);
  finally
    fileStream.Free();
    item.Free();
  end;

  SetStatusMsg(_('Finished.'));

  Result := retval;
end;

procedure TfrmFreeOTFEExplorerMain.tbbWithDropDownMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  TToolButton(Sender).CheckMenuDropdown();

end;


function TfrmFreeOTFEExplorerMain.StoreDir(path: WideString; dirToStore: string): boolean;
var
  allOK: boolean;
  fileIterator: TSDUFileIterator;
  nextItem: string;
  dirName: WideString;
  itemList: TSDDirItemList;
begin
  allOK := TRUE;

  dirName := ExtractFilename(dirToStore);

  SetStatusMsg(SDUParamSubstitute(_('Storing: %1...'), [dirName]));

  // Sanity check
  if allOK then
    begin
    allOK := DirectoryExists(dirToStore);
    end;

  if allOK then
    begin
    allOK := CreateSubDir(Path, dirName);
    if not(allOK) then
      begin
      // If the directory couldn't be created - check to see if it already
      // exists. If it does, ignore the creation error
      itemList:= TSDDirItemList.Create();
      try
        allOK := Filesystem.LoadContentsFromDisk(
                                      IncludeTrailingPathDelimiter(Path)+dirName,
                                      itemList
                                     );
      finally
        itemList.Free();
      end;
      end;
    end;

  if allOK then
    begin
    fileIterator:= TSDUFileIterator.Create(nil);
    try
      fileIterator.Directory := dirToStore;
      fileIterator.IncludeDirNames := TRUE;
      fileIterator.RecurseSubDirs := FALSE;  // Recursion carried out by this function calling StoreDir(...)
      fileIterator.Reset();
      nextItem := fileIterator.Next();
      while (nextItem <> '') do
        begin
        if DirectoryExists(nextItem) then
          begin
          allOK := StoreDir(
                            IncludeTrailingPathDelimiter(Path)+dirName,
                            nextItem
                           );
          end
        else
          begin
          allOK := StoreFile(
                            IncludeTrailingPathDelimiter(Path)+dirName,
                            nextItem
                           );
          end;

        if not(allOK) then
          begin
          break;
          end;

        nextItem := fileIterator.Next();
        end;
    finally
      fileIterator.Free();
    end;
    end;

  SetStatusMsg(_('Finished.'));

  Result := allOK;
end;

procedure TfrmFreeOTFEExplorerMain.PromptForAndImportDir(importToPath: WideString);
var
  srcPathStr: string;
begin
  if SDUSelectDirectory(
                        self.Handle,
                        _('Folder to store:'),
                        '',
                        srcPathStr
                       ) then
    begin                                               
    ImportDir(srcPathStr, importToPath, TRUE);
    end;
end;

function TfrmFreeOTFEExplorerMain.ImportDir(srcItem: WideString; importToPath: WideString; showMsgOnSuccess: boolean): boolean;
var
  allOK: boolean;
  item: TSDDirItem_FAT;
  opCompletedOK: boolean;
  prevCursor: TCursor;
begin
  allOK := TRUE;

  if allOK then
    begin
    item:= TSDDirItem_FAT.Create();
    try
      if Filesystem.GetItem(
                 IncludeTrailingPathDelimiter(importToPath)+
                 ExtractFilename(srcItem),
                 item
                ) then
        begin
        if item.IsFile then
          begin
          SDUMessageDlg(
                        SDUParamSubstitute(
                                           _('A file called ''%1'' already exists'),
                                           [ExtractFilename(srcItem)]
                                          ),
                        mtError
                       );
          allOK := FALSE;
          end
        else if item.IsDirectory then
          begin
          allOK := SDUConfirmYN(
                                  SDUParamSubstitute(
                                            _('This folder already contains a folder named ''%1''.'+SDUCRLF+
                                              SDUCRLF+
                                              'If the files in the existing folder have the same name as files in the folder you are moving or copying, they will be replaced. Do you will want to move or copy the folder?'),
                                           [ExtractFilename(srcItem)]
                                          )
                                  );
          end;
        end;

    finally
      item.Free();
    end;

    end;

    if allOK then
    begin
      prevCursor := Screen.Cursor;
      Screen.Cursor := crHourglass;
      try
        opCompletedOK := StoreDir(importToPath, srcItem);
      finally
        Screen.Cursor := prevCursor;
      end;

      if opCompletedOK then
        begin
        if showMsgOnSuccess then
          begin
          SDUMessageDlg(_('Folder stored successfully'), mtInformation);
          end;
        end
      else
        begin
        allOK := FALSE;
        SDUMessageDlg(_('Unable to store folder'+SDUCRLF+
                        SDUCRLF+
                        'Please ensure that there is enough free space available'),
                      mtError);
        end;

      // Refresh regardless
      actRefreshExecute(nil);
    end;

  Result := allOK;
end;

function TfrmFreeOTFEExplorerMain.ImportMultiple(srcItems: TStringList; importToPath: WideString; showMsgOnSuccess: boolean): boolean;
var
  i: integer;
  allOK: boolean;
begin
  allOK := TRUE;

  for i:=0 to (srcItems.Count - 1) do
    begin
    if DirectoryExists(srcItems[i]) then
      begin
      allOK := ImportDir(srcItems[i], importToPath, FALSE);
      end
    else if FileExists(srcItems[i]) then
      begin
      allOK := ImportFile(srcItems[i], importToPath, FALSE);
      end;
      
    if not(allOK) then
      begin
      break;
      end;
      
    end;

  if allOK then
    begin
    if showMsgOnSuccess then
      begin
      SDUMessageDlg(_('Files/folders stored successfully'), mtInformation);
      end;
    end;

  Result := allOK;  
end;

function TfrmFreeOTFEExplorerMain.CreateSubDir(path: WideString; newDirName: WideString): boolean;
begin
  Result := Filesystem.CreateDir(path, newDirName);
end;

function TfrmFreeOTFEExplorerMain.OTFEFreeOTFE(): TOTFEFreeOTFEDLL;
begin
  Result := TOTFEFreeOTFEDLL(OTFEFreeOTFEBase);
end;

function TfrmFreeOTFEExplorerMain.Mounted(): boolean;
var
  retval: boolean;
begin
  retval:= FALSE;

  if (Filesystem <> nil) then
    begin
    retval := Filesystem.Mounted;
    end;

  Result := retval;
end;


// Populate the supplied TStringList with the full path and filenames of the
// most recently touched/selected items
procedure TfrmFreeOTFEExplorerMain.GetSelectedItems(Sender: TObject; targets: TStringList);
var
  popupNode: TTreeNode;
  i: integer;
  currMenuItem: TMenuItem;
  useContextMenuNode: boolean;

begin
  useContextMenuNode := FALSE;
  if (Sender is TMenuItem) then
    begin
    currMenuItem := TMenuItem(Sender);
    while (currMenuItem <> nil) do
      begin
      if (currMenuItem.Owner = pmTreeView) then
        begin
        useContextMenuNode := TRUE;
        break;
        end;
      currMenuItem:= currMenuItem.Parent;
      end;
    end;

  if useContextMenuNode then
    begin
    popupNode := TTreeNode(pmTreeView.Tag);
    targets.Add(SDFilesystemTreeView1.PathToNode(popupNode));
    end
  else if (LastFocussed = lfTreeView) then
    begin
    targets.Add(SDFilesystemTreeView1.PathToNode(SDFilesystemTreeView1.Selected));
    end
  else if (LastFocussed = lfListView) then
    begin
    for i:=0 to (SDFilesystemListView1.Items.count - 1) do
      begin
      if SDFilesystemListView1.Items[i].Selected then
        begin
        targets.Add(IncludeTrailingPathDelimiter(SDFilesystemListView1.Path)+SDFilesystemListView1.DirItem[i].Filename);
        end;
      end;
    end;

end;


// Return the full path of the most recently touched/selected item
// e.g. In the case of the treeview popup menu, the path of the item the
// context menu was invoked for, otherwise either the treeview or listview's
// path 
function TfrmFreeOTFEExplorerMain.GetSelectedPath(Sender: TObject): string;
var
  popupNode: TTreeNode;
  currMenuItem: TMenuItem;
  useContextMenuNode: boolean;
  retval: string;
begin
  useContextMenuNode := FALSE;
  if (Sender is TMenuItem) then
    begin
    currMenuItem := TMenuItem(Sender);
    while (currMenuItem <> nil) do
      begin
      if (currMenuItem.Owner = pmTreeView) then
        begin
        useContextMenuNode := TRUE;
        break;
        end;
      currMenuItem:= currMenuItem.Parent;
      end;
    end;

  if useContextMenuNode then
    begin
    popupNode := TTreeNode(pmTreeView.Tag);
    retval := SDFilesystemTreeView1.PathToNode(popupNode);
    end
  else if (LastFocussed = lfTreeView) then
    begin
    retval := SDFilesystemTreeView1.PathToNode(SDFilesystemTreeView1.Selected);
    end
  else if (LastFocussed = lfListView) then
    begin
    retval := SDFilesystemListView1.Path;
    end;

  Result := retval;
end;

function TfrmFreeOTFEExplorerMain.UserGuideURL(): string;
begin
  Result := USERGUIDE_ONLINE_EXPLORER;
end;

END.


